/*****************************************************************************/
/* XBlood - make the root window bloody                                      */
/* Programed by Sakai Hiroaki.                                               */
/*                                                                           */
/* Copyright (c) 1998 Sakai Hiroaki.                                         */
/*                                                                           */
/* XBlood is a free software. You may copy or distribute                     */
/* the original XBlood freely.                                               */
/* But, you may not modify, translate and merge                              */
/* the original XBlood without permission of the author.                     */
/*****************************************************************************/
/* 1998/7/23                                                                 */
/*                                                                           */
/* ܥեȥơֺ湰μפͭޤ                      */
/* XBlood ϡե꡼եȤǤʲξΤȤǡ                         */
/* ͳ˻ѡۤƹޤ                                          */
/*                                                                           */
/* (1) ܥեȥΰޤԤ̵ǤǲѤ              */
/*     ۤ뤳ȤϤǤޤ                                            */
/* (2) ܥեȥΰޤԤ̵Ǥ              */
/*     뤳ȤϤǤޤ                                                */
/* (3) ܥեȥѤ뤳Ȥˤäȯ»            */
/*     ǤϻѼԤˤꡤԤϤǤ餤ޤ              */
/* (4) ܥեȥβɤС󥢥åפܿʤɤε̳ϡ            */
/*     Ԥˤϰڤޤ                                          */
/* (5) ѸΥɥȤܸΥɥȤδ֤˺ۤ            */
/*     ˤϡܸΥɥȤΤǤȤޤ            */
/* (6) ʾξ˹դǤʤϡѸʤΤȤޤ            */
/* (7) ˵ҤʳθˤĤƤϡܹˡ                */
/*     ΤȤޤ                                                    */
/*                                                                           */
/* ܥեȥۤȤϡͳ˺ۤƹޤ󤬡          */
/* ʤ٤ʤԤޤϢ򤯤                                  */
/* 湰μϢΥ᡼륢ɥ쥹ϡ                                      */
/* sakai@miya.ee.kagu.sut.ac.jp Ǥ                                       */
/* ոۤޤ顤Ϣ                          */
/*                                                                           */
/* XBlood ˴ޤޤۥեϰʲ̤Ǥ                           */
/*                                                                           */
/* COPYRIGHT.euc   ԡ饤                                              */
/* README.euc                                                            */
/* Makefile	ᥤե                                               */
/* xblood.c	                                                       */
/* xblood.1.gz	man ʸե                                           */
/*****************************************************************************/

/*****************************************************************************/
/* Include Header Files                                                      */
/*****************************************************************************/

#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<X11/Xlib.h>

/*****************************************************************************/
/* Difinitions of Some Parameters                                            */
/*****************************************************************************/

#define ON  1
#define OFF 0

#define DEFAULT_NUMBER 50
#define DEFAULT_MAXIMUM_SPEED 100
#define DEFAULT_MAXIMUM_WIDTH  20
#define DEFAULT_MAXIMUM_HEIGHT 50
#define DEFAULT_COLOR "red"
#define DEFAULT_STAY_FLAG ON
#define DEFAULT_WAIT 0

typedef struct XBlood {
  Display * display;
  int screen;
  Colormap colormap;
  int width, height;
  Window root_window;
  char * display_name;
  GC gc;
} XBlood;

typedef struct Blood {
  int number, maximum_speed, maximum_width, maximum_height;
  char * color;
  int stay_flag;
  int wait;
  XArc * point;
  int  * speed;
  int  * count;
  int depth;
} Blood;

static char * help_string =
"\n"
"XBlood - make the root window bloody\n"
"\n"
"SYNOPSIS\n"
"        xblood [ -options ... ]\n"
"\n"
"DESCRIPTION\n"
"        XBlood fills the root window with blood.\n"
"        Red, blue or green bloody window is very bad taste!\n"
"\n"
"OPTIONS\n"
"        -display [displayname]\n"
"                        The name of the X server to use.\n"
"        -h, -help       Output help message.\n"
"        -stay, -noflow  Blood stays the bottom of the root window.(Default)\n"
"        -nostay, -flow  Blood flows down through the root window.\n"
"        -number [x]     The number of bloody drops. Default value is 50.\n"
"        -speed [x]      The speed of droping. Default value is 100.\n"
"        -width [x]      The maximum size of bloody drops' width.\n"
"                        Default value is 20.\n"
"        -height [x]     The size of bloody drops' height.\n"
"                        Default value is 50.\n"
"        -color [color]  Bloody drops' color. Default is red.\n"
"        -wait [x]       Wait time. Default value is 0.\n"
"\n"
"AUTHOR\n"
"        Programed by Sakai Hiroaki.\n"
"        E-Mail:sakai@miya.ee.kagu.sut.ac.jp\n"
"\n"
"COPYRIGHT\n"
"        Copyright (c) 1998 Sakai Hiroaki.\n"
"\n"
"        XBlood is a free software. You may copy or distribute\n"
"        the original XBlood freely.\n"
"        But, you may not modify, translate and merge\n"
"        the original XBlood without permission of the author.\n"
"\n";

/*****************************************************************************/
/* Definitions of Functions                                                  */
/*****************************************************************************/

void SetDefaultValue(XBlood * xbp, Blood * bp)
{
  xbp->display_name = NULL;
  bp->number = DEFAULT_NUMBER;
  bp->maximum_speed  = DEFAULT_MAXIMUM_SPEED;
  bp->maximum_width  = DEFAULT_MAXIMUM_WIDTH;
  bp->maximum_height = DEFAULT_MAXIMUM_HEIGHT;
  bp->color = DEFAULT_COLOR;
  bp->stay_flag = DEFAULT_STAY_FLAG;
  bp->wait = DEFAULT_WAIT;
  bp->depth = 0;
}

void Help()
{
  printf("%s", help_string);
  exit (0);
}

void ReadParameter(XBlood * xbp, Blood * bp, int ac, char ** av)
{
  int i;
  for (i = 0; i < ac; i++) {
    if      (!strcmp(av[i], "-h"     )) Help();
    else if (!strcmp(av[i], "-help"  )) Help();
    else if (!strcmp(av[i], "-stay"  )) bp->stay_flag = ON;
    else if (!strcmp(av[i], "-nostay")) bp->stay_flag = OFF;
    else if (!strcmp(av[i], "-flow"  )) bp->stay_flag = OFF;
    else if (!strcmp(av[i], "-noflow")) bp->stay_flag = ON;
    if (i < ac - 1) {
      if      (!strcmp(av[i],"-display")) xbp->display_name  =      av[++i];
      else if (!strcmp(av[i],"-number" )) bp->number         = atoi(av[++i]);
      else if (!strcmp(av[i],"-speed"  )) bp->maximum_speed  = atoi(av[++i]);
      else if (!strcmp(av[i],"-width"  )) bp->maximum_width  = atoi(av[++i]);
      else if (!strcmp(av[i],"-height" )) bp->maximum_height = atoi(av[++i]);
      else if (!strcmp(av[i],"-color"  )) bp->color          =      av[++i];
      else if (!strcmp(av[i],"-wait"   )) bp->wait           = atoi(av[++i]);
    }
  }
}

void InitializeDisplay(XBlood * xbp)
{
  xbp->display = XOpenDisplay(xbp->display_name);
  xbp->screen = DefaultScreen(xbp->display);
  xbp->colormap = DefaultColormap(xbp->display, xbp->screen);
  xbp->width  =  DisplayWidth(xbp->display, xbp->screen);
  xbp->height = DisplayHeight(xbp->display, xbp->screen);
  xbp->root_window = RootWindow(xbp->display, xbp->screen);
}

void MakeBlood(XBlood * xbp, Blood * bp, int i)
{
  bp->point[i].x = (rand() % xbp->width);
  bp->point[i].y = (rand() % xbp->height) - bp->depth - 100;
  bp->point[i].width  = rand() % bp->maximum_width;
  bp->point[i].height = bp->maximum_height;
  bp->point[i].angle1 = 0;
  bp->point[i].angle2 = 360 * 64;
  bp->speed[i] = (rand() % bp->maximum_speed) + 1;
  bp->count[i] = 0;
}

unsigned long int GetColor(XBlood * xbp, char * color)
{
  XColor c0, c1;
  XAllocNamedColor(xbp->display, xbp->colormap, color, &c0, &c1);
  return (c0.pixel);
}

void InitializeBlood(XBlood * xbp, Blood * bp)
{
  int i;
  srand((unsigned)time(NULL));
  bp->point = (XArc *)malloc(sizeof(XArc) * bp->number);
  bp->speed = (int  *)malloc(sizeof(int ) * bp->number);
  bp->count = (int  *)malloc(sizeof(int ) * bp->number);
  for (i = 0; i < bp->number; i++) MakeBlood(xbp, bp, i);
  xbp->gc = XCreateGC(xbp->display, xbp->root_window, 0, 0);
  XSetForeground(xbp->display, xbp->gc, GetColor(xbp, bp->color));
  XSetArcMode(xbp->display, xbp->gc, ArcPieSlice);
}

void BloodMain(XBlood * xbp, Blood * bp)
{
  int i, j;
  while (bp->depth < xbp->height) {
    XFillArcs(xbp->display, xbp->root_window, xbp->gc, bp->point, bp->number);
    for (j = 0; j < bp->number; j++) {
      bp->count[j] += bp->speed[j];
      while (bp->count[j] >= 100) {
	bp->count[j] -= 100;
	(bp->point[j].y)++;
      }
      if (bp->point[j].y >= xbp->height - bp->depth) {
	if (bp->stay_flag == ON) {
	  (bp->depth)++;
	  XFillRectangle(xbp->display, xbp->root_window, xbp->gc,
			 0, xbp->height - bp->depth, xbp->width, bp->depth);
	}
	MakeBlood(xbp, bp, j);
      }
    }
    XFlush(xbp->display);
    usleep(bp->wait);
  }
}

void BloodQuit(XBlood * xbp, Blood * bp)
{
  free(bp->point);
  free(bp->speed);
  free(bp->count);
  XCloseDisplay(xbp->display);
  exit (0);
}

main(int argc, char ** argv)
{
  XBlood xblood;
  Blood blood;

  SetDefaultValue(&xblood, &blood);
  ReadParameter(&xblood, &blood, argc, argv);
  InitializeDisplay(&xblood);
  InitializeBlood(&xblood, &blood);
  BloodMain(&xblood, &blood);
  BloodQuit(&xblood, &blood);
}

/*****************************************************************************/
/* End of XBlood                                                             */
/*****************************************************************************/
